## Much, much faster; Many, many contributors

Thanks to the contributions of many (see below), elm-format is now much faster.
(Testers of the pre-release saw an 11x speedup on MacOS ARM, and a 4x speedup on other platforms.)

New features:
  - File are now processed in parallel

Bug fixes:
  - `module exposing` listings containing comments no longer add extra leading spaces
  - Redundant import aliases (when the alias is the same as the module name) are now removed

Other changes:
  - Native binaries are now provided for MacOS ARM64 (previous versions required Rosetta)
  - Native (statically-linked) binaries are now provided for Linux ARM64 (aarch64)
  - The npm installer now has zero dependencies
  - Performance optimization, making use of Elm 0.19's parser, thanks to @emmabastas's contributions via Google Summer of Code


## Install

```sh
npm install -g elm-format
```

or [download from the release page](https://github.com/avh4/elm-format/releases/tag/0.8.6).


## Thanks to ...

  - @emmabastas for refactoring the parser internals to integrate Elm 0.19's compiler's parser
  - @lydell for processing files in parallel
  - @lydell for the new dependency-free npm installer script
  - @mdevlamynck for the `exposing` listings bug fix
  - @tfausak for linux-aarch64 build script updates
  - @supermario for mac-arm64 build script updates
  - [Lamdera](https://www.lamdera.com/) for providing CI runners to build the MacOS ARM64 release binaries
  - Elm community members for testing the new binaries and npm packages
  - ... and anyone who's contributed to cross-compilation support in ghc or nix in the past two years
